OnlineShop/urls.py
from django.conf.urls.i18n import i18n_patterns
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from app.accounts.views import LogoutView

urlpatterns = [
    path('admin/logout/', LogoutView.as_view(), name='logout'),
    path('admin/', admin.site.urls),
    path("__debug__/", include("debug_toolbar.urls")),
    path('ckeditor/', include('ckeditor_uploader.urls')),
] + i18n_patterns(
    path('i18n/', include('django.conf.urls.i18n')),
    path('', include('app.products.urls')),
    path('users/', include("app.accounts.urls")),
    path('order/', include('app.order.urls')),
)

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

app/accounts/urls.py
from django.urls import path
from .views import LoginView, LogoutView, RegisterView, ProfileView, ProfileUpdateView, PasswordChangeView, OrderDetailView, user_info


app_name = 'accounts'
urlpatterns = [
    path("register/", RegisterView.as_view(), name="register"),
    path("login/", LoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(), name="logout"),
    path("profile/", ProfileView.as_view(), name="profile"),
    path('order-detail/<uuid:uuid>/', OrderDetailView.as_view(), name='order_detail'),
    path("profile/edit/", ProfileUpdateView.as_view(), name="profile-edit"),
    path('password-change/', PasswordChangeView.as_view(), name='password_change'),
    path('admin-info/',user_info, name='admin_info')
]

app/products/urls.py
from django.urls import path
from .views import HomePage, ShopView, ShopViewAll, ShopDetailView, ProductCommentView, SearchResultsView, OrgShopView

app_name = 'products'
urlpatterns = [
    path('', HomePage.as_view(), name='home'),
    path('shop/', ShopViewAll.as_view(), name='shop'),
    path('shop/<uuid:uuid>/', ShopView.as_view(), name='shop'),
    path('product/<slug:slug>/<uuid:uuidd>/', ShopDetailView.as_view(), name='shop_detail'),
    path('comment/<uuid:uuid>/', ProductCommentView.as_view(), name='comment_create'),
    path('search/', SearchResultsView.as_view(), name='search'),
    path('org/<uuid:uuid>', OrgShopView.as_view(), name='org')
]

app/accounts/models.py
from django.db import models
from django.contrib.auth.models import AbstractUser
from app.base.models import BaseModel

# Create your models here.

class User(AbstractUser):
    phone = models.CharField(max_length=50, null=True, blank=True)
    photo = models.ImageField(upload_to='profile/', default='profile/profile.svg')

    def save(self, *args, **kwargs):
        # Auto-generate username based on phone number
        if self.username:
            self.phone = self.username
        super().save(*args, **kwargs)

    def get_full_name(self):
        return f"{self.first_name} {self.last_name}"

    def __str__(self):
        return self.username


class Organization(BaseModel):
    name = models.CharField(max_length=255)
    avatar = models.FileField(upload_to="Organizations", null=True, blank=True)
    banner = models.FileField(upload_to="Organizations", null=True, blank=True)
    user = models.OneToOneField(
        User, on_delete=models.CASCADE,
        related_name='organization',
    )
    telegram_group_id = models.CharField(max_length=255, null=True, blank=True)
    address = models.CharField(max_length=255, null=True, blank=True)
    telegram = models.CharField(max_length=255, null=True, blank=True)
    instagram = models.CharField(max_length=255, null=True, blank=True)
    facebook = models.CharField(max_length=255, null=True, blank=True)


    def __str__(self):
        return self.name


class Tariff(BaseModel):
    name = models.CharField(max_length=255)
    price = models.PositiveIntegerField(default=0)

    def __str__(self) -> str:
        return self.name


class Contract(BaseModel):
    organization = models.OneToOneField(Organization, on_delete=models.CASCADE, related_name='organization')
    company_type = models.CharField(max_length=2555, verbose_name='firma turi')
    mfo = models.CharField(max_length=50, null=True, blank=True, verbose_name='mfo')
    oked = models.CharField(max_length=50, null=True, blank=True, verbose_name='oked')
    inn = models.CharField(max_length=20, verbose_name='inn')
    statute = models.FileField(upload_to='ustav/', verbose_name='ustav')
    certificate = models.FileField(upload_to='guvohnoma/', name='guvohnoma')
    director_passport = models.FileField(upload_to='director_passport/', verbose_name='direktor pasport')
    tariff = models.ForeignKey(Tariff, on_delete=models.CASCADE, related_name='organization')

    def __str__(self) -> str:
        return self.organization.name

app/accounts/forms.py
from django import forms
from django.contrib.auth import password_validation
from django.contrib.auth.forms import AuthenticationForm
from django.forms.widgets import PasswordInput, TextInput
from django.contrib.auth.forms import PasswordChangeForm

from .models import User

class CustomAuthForm(AuthenticationForm):
    username = forms.CharField(widget=TextInput(attrs={'class':'validate','placeholder': '+998997980727'}))
    password = forms.CharField(widget=PasswordInput(attrs={'placeholder':'Password'}))


class UserCreateForm(forms.ModelForm):
    first_name = forms.CharField(widget=TextInput(attrs={'placeholder': 'First Name'}), required=True)
    last_name = forms.CharField(widget=TextInput(attrs={'placeholder': 'Last Name'}), required=True)
    username = forms.CharField(widget=TextInput(attrs={'placeholder': '+998997980727'}), required=True)
    password = forms.CharField(widget=PasswordInput(attrs={'placeholder':'Password'}), required=True)
    confirm_password = forms.CharField(widget=PasswordInput(attrs={'placeholder':'Confirm Password'}), required=True)



    class Meta:
        model = User
        fields = ('first_name', 'last_name', 'username')

    def clean_username(self):
        username = self.cleaned_data['username']
        # Check if the username is already in use
        if User.objects.filter(username=username).exists():
            raise forms.ValidationError("Bu telefon raqam bilan foydalanuvchi ro'yxatdan o'tgan")

        return username
    def clean_confirm_password(self):
        data = self.cleaned_data
        if data['password'] != data['confirm_password']:
            raise forms.ValidationError("Ikkala parolingiz ham bir-biriga teng bo'lishi kerak!")
        return data['confirm_password']
    def save(self, commit=True):
        user = super().save(commit)
        user.set_password(self.cleaned_data['confirm_password'])
        user.save()

        return user


class UserUpdateForm(forms.ModelForm):
    class Meta:
        model = User
        fields = ('first_name', 'last_name', 'photo')


class ChangePasswordForm(PasswordChangeForm):
    old_password = forms.CharField(
        strip=False
    )
    new_password1 = forms.CharField(
        strip=False,
        help_text=password_validation.password_validators_help_text_html(),
    )
    new_password2 = forms.CharField(
        strip=False
    )

app/accounts/views.py
from django.shortcuts import render
from django.contrib import messages
from django.contrib.auth import login, logout
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import render, redirect
from django.views import View
from .forms import UserCreateForm, CustomAuthForm, UserUpdateForm, ChangePasswordForm
from app.order.models import Order
from django.http import JsonResponse
from django.contrib.auth.decorators import login_required

@login_required
def user_info(request):

    org = None
    try:
        org = request.user.organization.avatar.url
    except:
        org = None
    user_data = {
        'photo': request.user.photo.url,
        'org': org,
    }
    return JsonResponse(user_data)

# Create your views here.
class RegisterView(View):
    form_class = UserCreateForm
    def get(self, request):
        create_form = self.form_class
        context = {
            "form": create_form
        }
        return render(request, "accounts/register.html", context)

    def post(self, request):
        create_form = self.form_class(data=request.POST)
        if create_form.is_valid():
            create_form.save()
            return redirect('accounts:login')
        else:
            messages.error(request, f"{create_form.errors}")
            context = {
                "form": create_form
            }
            return render(request, "accounts/register.html", context)


class LoginView(View):
    form_class = CustomAuthForm
    def get(self, request):
        if request.user.is_authenticated:
            return redirect('products:home')
        else:
            login_form = self.form_class

            return render(request, "accounts/login.html", {"login_form": login_form})

    def post(self, request):
        url = request.META.get('HTTP_REFERER')
        
        login_form = self.form_class(data=request.POST)

        if login_form.is_valid():
            user = login_form.get_user()
            login(request, user)

            messages.success(request, "You have successfully logged in.")

            return redirect('products:home')
        else:
            return render(request, "accounts/login.html", {"login_form": login_form})


class LogoutView(LoginRequiredMixin, View):
    def get(self, request):
        logout(request)
        messages.info(request, "You have successfully logged out.")
        return redirect("products:home")

class ProfileView(LoginRequiredMixin, View):
    def get(self, request):
        my_order = Order.objects.filter(user = request.user)
        context = {
            "user": request.user,
            'my_order' : my_order
            }
        return render(request, "accounts/profile.html", context)

class ProfileUpdateView(LoginRequiredMixin, View):
    form_class = UserUpdateForm
    def post(self, request):
        user_update_form = self.form_class(
            instance=request.user,
            data=request.POST,
            files=request.FILES
        )

        if user_update_form.is_valid():
            user_update_form.save()
            messages.success(request, "You have successfully updated your profile.")

            return redirect("accounts:profile")
        else:
            messages.success(request, f"{user_update_form.errors}")
            return redirect("accounts:profile")

        


class PasswordChangeView(LoginRequiredMixin,View):
    from_class = ChangePasswordForm
    def post(self, request):
        form = ChangePasswordForm(request.user, request.POST)
        if form.is_valid():
            form.save()

            messages.success(request, "Password changed successfully")
            return redirect('accounts:login')
        else:
            messages.error(request, f"{form.errors}")
            return redirect('accounts:profile')   
        

   
class OrderDetailView(View):
    def get(self, request, uuid):
        my_order = Order.objects.get(user = request.user, uuid=uuid)
        context = {
            'order' : my_order
            }
        return render(request, "order-confirmed-shop.html", context)

templates/accounts/login.html
{% extends 'base.html' %}
{% load i18n %}

{% block content %}
    <main class="main">
        <div class="page-header breadcrumb-wrap">
            <div class="container">
                <div class="breadcrumb">
                    <a href="{% url 'products:home' %}" rel="nofollow">{% blocktranslate %} Bosh Sahifa {% endblocktranslate %}</a>
                    <span></span> {% blocktranslate %} Tizimga kirish {% endblocktranslate %}
                </div>
            </div>
        </div>
        <section class="pt-150 pb-150">
            <div class="container">
                <div class="row">
                    <div class="col-lg-10 m-auto">
                        <div class="row">
                            <div class="col-lg-5">
                                <div class="login_wrap widget-taber-content p-30 background-white border-radius-10">
                                    <div class="padding_eight_all bg-white">
                                        <div class="heading_s1">
                                            <h3 class="mb-30">{% blocktranslate %} Tizimga kirish {% endblocktranslate %}</h3>
                                        </div>
                                        <form method="post">{% csrf_token %}

                                            <div class="form-group">
                                                {{ login_form.username }}
                                            </div>
                                            <div class="form-group">
                                                {{ login_form.password }}

                                            </div>
                                            <div class="login_footer form-group">
                                                <div class="chek-form">
                                                    <div class="custome-checkbox">
                                                        <input class="form-check-input" type="checkbox" name="checkbox" id="exampleCheckbox1" value="">
                                                        <label class="form-check-label" for="exampleCheckbox1"><span>{% blocktranslate %} Meni eslab qol {% endblocktranslate %}</span></label>
                                                    </div>
                                                </div>
                                                <a class="text-muted" href="#">{% blocktranslate %} Parolni unutdingizmi? {% endblocktranslate %}</a>
                                            </div>
                                            <div class="form-group">
                                                <button type="submit" class="btn btn-fill-out btn-block hover-up" name="login">{% blocktranslate %} Tizimga kirish {% endblocktranslate %}</button>
                                                <a href="{% url 'accounts:register' %}" class="d-flex align-items-start text-muted justify-content-end">{% blocktranslate %} Ro'yxatdan o'tish {% endblocktranslate %}</a>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>
    </main>

{% endblock content %}

templates/accounts/register.html
{% extends 'base.html' %}
{% load i18n %}

{% block content %}
    <main class="main">
        <div class="page-header breadcrumb-wrap">
            <div class="container">
                <div class="breadcrumb">
                    <a href="index.html" rel="nofollow">{% blocktranslate %} Bosh Sahifa {% endblocktranslate %}</a>
                    <span></span> {% blocktranslate %} Ro'yxatdan o'tish {% endblocktranslate %}
                </div>
            </div>
        </div>
        <section class="pt-150 pb-150">
            <div class="container">
                <div class="row">
                    <div class="col-lg-10 m-auto">
                        <div class="row">
                            <div class="col-lg-6">
                                <div class="login_wrap widget-taber-content p-30 background-white border-radius-5">
                                    <div class="padding_eight_all bg-white">
                                        <div class="heading_s1">
                                            <h3 class="mb-30">{% blocktranslate %} Hisob ochish {% endblocktranslate %}</h3>
                                        </div>
                                        <p class="mb-50 font-sm">
                                            {% blocktranslate %} Sizning shaxsiy ma'lumotlaringiz ushbu veb-saytdagi amalyotlaringizni qo'llab-quvvatlash, hisobingizga kirishni boshqarish va maxfiylik siyosatimizda tasvirlangan boshqa maqsadlarda foydalaniladi. {% endblocktranslate %}
                                        </p>
                                        <form method="post">{% csrf_token %}

                                            <div class="form-group">

                                                {{ form.first_name }}
                                            </div>
                                            <div class="form-group">

                                                {{ form.last_name }}
                                            </div>
                                            <div class="form-group">

                                                {{ form.username }}
                                            </div>

                                            <div class="form-group">

                                                {{ form.password }}
                                            </div>

                                            <div class="form-group">

                                                {{ form.confirm_password }}
                                            </div>
                                            
                                            <div class="form-group">
                                                <button type="submit" class="btn btn-fill-out btn-block hover-up" name="login">{% blocktranslate %} Yuborish {% endblocktranslate %} &amp; {% blocktranslate %} Ro'yxatdan o'tish {% endblocktranslate %}</button>
                                            </div>
                                        </form>
                                        <div class="divider-text-center mt-15 mb-15">
                                            <span>{% blocktranslate %} Yoki {% endblocktranslate %}</span>
                                        </div>
                                        <div class="text-muted text-center">{% blocktranslate %} Hisobingiz bormi? {% endblocktranslate %}<a href="{% url 'accounts:login' %}">{% blocktranslate %} Hozir kiring {% endblocktranslate %}</a></div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>
    </main>

{% endblock content %}